#!/usr/bin/perl
# commview.cgi
# Change a post, including colateral data

use warnings ;
use strict ;
use DB_File ;

require "session.pl";

## DECLARATIONS
our $dbdir;
require "../conf.pl"; #get $dbdir value from ../conf.pl
$dbdir = "../".$dbdir; #fix $dbdir

# test $ENV{'QUERY_STRING'}
if( length($ENV{'QUERY_STRING'})>30 || index($ENV{'QUERY_STRING'},"id")!=0 ) { print "Content-type: text/html; charset=utf-8\n\n<html><body><p>Error0, with input data: ".index($ENV{'QUERY_STRING'},"borrar")."</p></body></html>"; exit 0;}
my @pairs = split(/&/, $ENV{'QUERY_STRING'}); # separating variables
my ($name, $value) = split(/=/,@pairs[0]);
if($name ne "id") { print "Content-type: text/html; charset=utf-8\n\n<html><body><p>Error1, with input data</p></body></html>"; exit 0;}
my $id=$value;
my ($name, $value) = split(/=/,@pairs[1]);
if($name ne "num") { print "Content-type: text/html; charset=utf-8\n\n<html><body><p>Error2, with input data</p></body></html>"; exit 0;}
my $num=$value;

## OPENING DATABASES

sub Compare { my ($key1,$key2)=@_; "\L$key2" cmp "\L$key1"; } # getting first the last post
$DB_BTREE->{'compare'} = \&Compare ; # specify the Perl sub that will do the comparison

$DB_BTREE->{'flags'} = R_DUP ; # permit duplication in next DB's

my ($comments, %comments) ; # to handle COMMENTS DB
$comments = tie %comments, "DB_File", $dbdir."habla_comments.db", O_RDWR|O_CREAT, 0666, $DB_BTREE # opendb, if it does not exist create
	or die "Cannot open file 'comments': $!\n" ; # error :(

# Comment to delete

my @list = sort $comments->get_dup($id) ; # get a sort list of comments for actual post. Last one in the botton.
my $cadena=@list[$num] ; #will store value of pair (key,value) what we want to delete
$comments->del_dup($id,$cadena) ;

### CREATING HTML  # http server head
print "Content-type: text/html; charset=utf-8\n\n
<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n
<html><head>\n<title>Habla_</title>
<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">
</head><body>\n";
print "<p>Comment deleted: ".$cadena."</p>\n<p>From post: ".$id."</p>
<p><a href=\"commview.cgi?id=".$id."\">Other comments from this post</a></p>
<p><a href=\"panel_manage.cgi\">Go to panel</a></p>
</body></html>";


### CLOSING DATABASES

undef $comments ; untie %comments ;
1;